#include "construct.h"

/* Hauteur d'une piece: 2.54 ou 3.54 */

/* Couleurs des pices: rouge et bleu */
float rouge[]={0.7,0.2,0.2,1.};
float bleu[]={0.2,0.2,0.7,1.};

/* Rayon d'un "rond" sur le plateau */
float taille = 15;

/* Les points servant  calculer les normales */
point v,v1,v2;

float a, b;

void face(point* tab, int mode)
{
       if (mode == FACE_TRIANGLE)
       {
            CreerVecteur(&tab[0],&tab[1],&v1);
			CreerVecteur(&tab[0],&tab[2],&v2);
			ProduitVectoriel(&v1,&v2,&v);
			glNormal3f(v.x,v.y,v.z);
			glVertex3f(tab[0].x,tab[0].y,tab[0].z);
			glVertex3f(tab[1].x,tab[1].y,tab[1].z);
			glVertex3f(tab[2].x,tab[2].y,tab[2].z);
        }
		else if (mode == FACE_QUAD)
		{
			CreerVecteur(&tab[0],&tab[1],&v1);
			CreerVecteur(&tab[0],&tab[3],&v2);
			ProduitVectoriel(&v1,&v2,&v);
			glNormal3f(v.x,v.y,v.z);
			glVertex3f(tab[0].x,tab[0].y,tab[0].z);
			glVertex3f(tab[1].x,tab[1].y,tab[1].z);
			glVertex3f(tab[2].x,tab[2].y,tab[2].z);
			glVertex3f(tab[3].x,tab[3].y,tab[3].z);
        }
}

void construire_piece(int couleur, int hauteur, int remplissage, int cotes)
{
	int i;
    
    point * tab = (point*) malloc (sizeof(point)*4);
	
    if (hauteur != 0) hauteur = 1.5;
	
	glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,(couleur==0)?rouge:bleu);

	glBegin(GL_TRIANGLES);
		for (i=0; i<cotes; i++)
		{
			a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			tab[0].x = 0;
			tab[0].y = 0;
			tab[0].z = 0;
			
			tab[1].x = cos(a);
			tab[1].y = 0;
			tab[1].z = sin(a);
			
			tab[2].x = cos(b);
			tab[2].y = 0;
			tab[2].z = sin(b);
			
			face(tab,FACE_TRIANGLE);			
		}
	glEnd();
		
	glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = cos(a);
			tab[0].y = 0;
			tab[0].z = sin(a);

			tab[1].x = cos(a);
			tab[1].y = 1.5;
			tab[1].z = sin(a);

			tab[2].x = cos(b);
			tab[2].y = 1.5;
			tab[2].z = sin(b);

			tab[3].x = cos(b);
			tab[3].y = 0;
			tab[3].z = sin(b);

			face(tab,FACE_QUAD);
        }
    glEnd();
   
    glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = cos(a);
			tab[0].y = 1.5;
			tab[0].z = sin(a);

			tab[1].x = 0.8*cos(a);
			tab[1].y = 1.5;
			tab[1].z = 0.8*sin(a);

			tab[2].x = 0.8*cos(b);
			tab[2].y = 1.5;
			tab[2].z = 0.8*sin(b);

			tab[3].x = cos(b);
			tab[3].y = 1.5;
			tab[3].z = sin(b);

			face(tab,FACE_QUAD);
        }
    glEnd();
    
    glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = 0.8*cos(a);
			tab[0].y = 1.5;
			tab[0].z = 0.8*sin(a);

			tab[1].x = 0.8*cos(a);
			tab[1].y = 1.7;
			tab[1].z = 0.8*sin(a);

			tab[2].x = 0.8*cos(b);
			tab[2].y = 1.7;
			tab[2].z = 0.8*sin(b);

			tab[3].x = 0.8*cos(b);
			tab[3].y = 1.5;
			tab[3].z = 0.8*sin(b);

			face(tab,FACE_QUAD);
        }
    glEnd();
    
    glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = 0.8*cos(a);
			tab[0].y = 1.7;
			tab[0].z = 0.8*sin(a);

			tab[1].x = cos(a);
			tab[1].y = 1.7;
			tab[1].z = sin(a);

			tab[2].x = cos(b);
			tab[2].y = 1.7;
			tab[2].z = sin(b);

			tab[3].x = 0.8*cos(b);
			tab[3].y = 1.7;
			tab[3].z = 0.8*sin(b);

			face(tab,FACE_QUAD);
        }
    glEnd();
    
    glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = cos(a);
			tab[0].y = 1.7;
			tab[0].z = sin(a);

			tab[1].x = cos(a);
			tab[1].y = 2.4+hauteur;
			tab[1].z = sin(a);

			tab[2].x = cos(b);
			tab[2].y = 2.4+hauteur;
			tab[2].z = sin(b);

			tab[3].x = cos(b);
			tab[3].y = 1.7;
			tab[3].z = sin(b);

			face(tab,FACE_QUAD);
        }
    glEnd();
    
    glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = cos(a);
			tab[0].y = 2.4+hauteur;
			tab[0].z = sin(a);

			tab[1].x = 0.87*cos(a);
			tab[1].y = 2.4+hauteur+0.14;
			tab[1].z = 0.87*sin(a);

			tab[2].x = 0.87*cos(b);
			tab[2].y = 2.4+hauteur+0.14;
			tab[2].z = 0.87*sin(b);

			tab[3].x = cos(b);
			tab[3].y = 2.4+hauteur;
			tab[3].z = sin(b);

			face(tab,FACE_QUAD);
        }
    glEnd();
    
    if (remplissage != 0)
    {
        glBegin(GL_TRIANGLES);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = 0.87*cos(a);
			tab[0].y = 2.4+hauteur+0.14;
			tab[0].z = 0.87*sin(a);

			tab[1].x = 0;
			tab[1].y = 2.4+hauteur+0.14;
			tab[1].z = 0;

			tab[2].x = 0.87*cos(b);
			tab[2].y = 2.4+hauteur+0.14;
			tab[2].z = 0.87*sin(b);

			face(tab,FACE_TRIANGLE);
        }
        glEnd();
    } else {
        glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = 0.87*cos(a);
			tab[0].y = 2.4+hauteur+0.14;
			tab[0].z = 0.87*sin(a);

			tab[1].x = 0.6*cos(a);
			tab[1].y = 2.4+hauteur+0.14;
			tab[1].z = 0.6*sin(a);

			tab[2].x = 0.6*cos(b);
			tab[2].y = 2.4+hauteur+0.14;
			tab[2].z = 0.6*sin(b);

			tab[3].x = 0.87*cos(b);
			tab[3].y = 2.4+hauteur+0.14;
			tab[3].z = 0.87*sin(b);

			face(tab,FACE_QUAD);
        }
        glEnd();
        
        glBegin(GL_QUADS);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = 0.6*cos(a);
			tab[0].y = 2.4+hauteur+0.14;
			tab[0].z = 0.6*sin(a);

			tab[1].x = 0.6*cos(a);
			tab[1].y = 2.4+hauteur;
			tab[1].z = 0.6*sin(a);

			tab[2].x = 0.6*cos(b);
			tab[2].y = 2.4+hauteur;
			tab[2].z = 0.6*sin(b);

			tab[3].x = 0.6*cos(b);
			tab[3].y = 2.4+hauteur+0.14;
			tab[3].z = 0.6*sin(b);
			
            face(tab,FACE_QUAD);
        }
        glEnd();
        
        glBegin(GL_TRIANGLES);
        for (i=0; i<cotes; i++)
        {
            a = i*2*M_PI/cotes;
			b = (i+1)*2*M_PI/cotes;
			
			tab[0].x = 0.6*cos(a);
			tab[0].y = 2.4+hauteur;
			tab[0].z = 0.6*sin(a);

			tab[1].x = 0;
			tab[1].y = 1.8+hauteur;
			tab[1].z = 0;

			tab[2].x = 0.6*cos(b);
			tab[2].y = 2.4+hauteur;
			tab[2].z = 0.6*sin(b);

			face(tab,FACE_TRIANGLE);
        }
        glEnd();
    }
}

void construire_rond()
{
	int i;
	
	point * tab = (point*) malloc (sizeof(point)*4);
 
    glBegin(GL_QUADS);
    for (i=0; i<100; i++)
    {	
        a = i*2*M_PI/100;
		b = (i+1)*2*M_PI/100;
		
		tab[0].x = taille*cos(a);
		tab[0].y = 0;
		tab[0].z = taille*sin(a);

		tab[1].x = taille*cos(a);
		tab[1].y = 3;
		tab[1].z = taille*sin(a);

		tab[2].x = taille*cos(b);
		tab[2].y = 3;
		tab[2].z = taille*sin(b);

		tab[3].x = taille*cos(b);
		tab[3].y = 0;
		tab[3].z = taille*sin(b);
			
    	face(tab,FACE_QUAD);
       }
   	glEnd();		
		
	glBegin(GL_TRIANGLES);
	for (i=0; i<100; i++)
	{
		a = i*2*M_PI/100;
		b = (i+1)*2*M_PI/100;
		tab[0].x = taille*cos(a);
		tab[0].y = 3;
		tab[0].z = taille*sin(a);
		
		tab[1].x = 0;
		tab[1].y = 3;
		tab[1].z = 0;
			
		tab[2].x = taille*cos(b);
		tab[2].y = 3;
		tab[2].z = taille*sin(b);
			
		face(tab,FACE_TRIANGLE);		
	}
	glEnd();
}
