#include "quarto.h"

/* Dimensions du plateau */
/*************************/
float largeur= 80;
float hauteur= 2;
float profondeur= 80;

/* Couleurs */
/************/
float blanc[] = {1, 1, 1, 1};
float noir[] = {0, 0, 0, 1};
float orange[] = {1, .5, 0, 1};
float vert[] = {0, .6, 0, 1};
float rose[] = {1, .5, .5, 1};

/* Composantes Lumieres */
/************************/
float lum_blanche[] = {.5, .5, .5, 1};
float lum_speculaire[] = {.6, .6, .6, 1};
float lum_nulle[] = {0, 0, 0, 1};
float lum_peu_speculaire[] = {.3, .3, .3, 1};
float eclat = 16;

/* Position des lumires */
/*************************/
// Light0 : Lumiere principale
float lum_position[] = {0, 100, 0, 1};

// Light1 : Spot sur la pice slctionne
float spot_piece[4] = {0, -4900, 100, 1};
float direction_spot_piece[] = {0, -1, -1};

// Light2 : Spot sur la case du plateau
float spot_case[4] = {-52, 19, -52, 1};
float direction_spot_case[] = {0, -1, 0};

// Light3 : Spot sur la pice autour du plateau
float spot_autour[4] = {0, 60, 0, 1};
float direction_spot_autour[] = {0, -50, 0};

/* tableau des cases du plateau, -1 si vide, sinon numero de la piece */
/**********************************************************************/
int tableau[4][4];

/* Position de l'observateur */
/*****************************/
float obsY = 400;
float obsX;
float obsZ;

/* Variables de gestion des pieces */
/***********************************/
int pieces[16];
int piece_rainure[16];
point position[16];
point rainure[16];
point curseur;

/* Angles pour les rotations */
/*****************************/
float angle_cone = 0;
float angle_piece = 0;
float angle_obs = 0;

/* Listes d'affichage */
/**********************/
int rond, plateau, cone, surface;

/* Valeurs du jeu */
/******************/
int nbPieces;
int joueur;
int courante;
int mode_jeu;
int victoire;
int tabX, tabY, rainX;
char message[128];
char message2[128];
char joueur1[32];
char joueur2[32];
int nb_capture= 0;
char path[20];

/* Animation de Victoire */
/*************************/
float pas[4];
int pieces_vict[4];

/* Dfinition des textures */
/***************************/
unsigned char image[256*256*3];
unsigned char texture[256][256][3];


/************************************/
/* Initialisation des Objets du jeu */
/************************************/

void initObjets()
{
    construction_pieces();	
    construction_curseur();
	construction_plateau();
	construction_rond();
	construction_surface();
}

/************************************************************************/
/* Cration d'un rond color pour le choix de l'emplacement d'une pice */
/************************************************************************/

void construction_rond()
{	
	rond = glGenLists(1);
	glNewList(rond, GL_COMPILE);
		glPushMatrix();
            glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, orange);
    		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lum_speculaire);
        	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, eclat);
            construire_rond();
        glPopMatrix();
	glEndList();
}

/************************************/
/* Cration du plateau avec texture */
/************************************/

void construction_plateau()
{	
	glEnable(GL_TEXTURE_2D) ;
    plateau = glGenLists(1);
	glNewList(plateau, GL_COMPILE);		
        glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, vert);
    	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lum_nulle);
        glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, eclat);
		
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, texture) ;
  			
			glBegin(GL_POLYGON);
                glNormal3d(0.0,0.0,1.0);
                glTexCoord2f(0.0, 1.0); glVertex3d(-largeur, hauteur, profondeur);
                glTexCoord2f(1.0, 1.0); glVertex3d(-largeur, -hauteur, profondeur);
                glTexCoord2f(1.0, 0.0); glVertex3d( largeur, -hauteur, profondeur);
                glTexCoord2f(0.0, 0.0); glVertex3d( largeur, hauteur, profondeur);
            glEnd();
            glBegin(GL_POLYGON);
                glNormal3d(0.0,0.0,-1.0);
                glTexCoord2f(0.0, 1.0); glVertex3d( largeur, hauteur, -profondeur);
                glTexCoord2f(0.0, 0.0); glVertex3d( largeur, -hauteur, -profondeur);
                glTexCoord2f(1.0, 0.0); glVertex3d( -largeur, -hauteur, -profondeur);
                glTexCoord2f(1.0, 1.0); glVertex3d( -largeur, hauteur, -profondeur);
            glEnd();
            glBegin(GL_POLYGON);
                glNormal3d(1.0,0.0,0.0);
                glTexCoord2f(0.0, 0.0); glVertex3d( largeur, hauteur, profondeur);
                glTexCoord2f(1.0, 0.0); glVertex3d( largeur, -hauteur, profondeur);
                glTexCoord2f(1.0, 1.0); glVertex3d( largeur, -hauteur, -profondeur);
                glTexCoord2f(0.0, 1.0); glVertex3d( largeur, hauteur, -profondeur);
            glEnd();
            glBegin(GL_POLYGON);
                glNormal3d(-1.0,0.0,0.0);
                glTexCoord2f(0.0, 0.0); glVertex3d( -largeur, hauteur, profondeur);
                glTexCoord2f(1.0, 0.0); glVertex3d( -largeur, hauteur, -profondeur);
                glTexCoord2f(1.0, 1.0); glVertex3d( -largeur, -hauteur, -profondeur);
                glTexCoord2f(0.0, 1.0); glVertex3d( -largeur, -hauteur, profondeur);
            glEnd();
            glBegin(GL_POLYGON);
                glNormal3d(0.0,-1.0,0.0);
                glTexCoord2f(0.0, 0.0); glVertex3d( -largeur, -hauteur, profondeur);
                glTexCoord2f(1.0, 0.0); glVertex3d( -largeur, -hauteur, -profondeur);
                glTexCoord2f(1.0, 1.0); glVertex3d( largeur, -hauteur, -profondeur);
                glTexCoord2f(0.0, 1.0); glVertex3d( largeur, -hauteur, profondeur);
            glEnd();
            glBegin(GL_POLYGON);
                glNormal3d(0.0,1.0,0.0);
                glTexCoord2f(0.0, 0.0); glVertex3d( -largeur, hauteur, profondeur);
                glTexCoord2f(1.0, 0.0); glVertex3d( largeur, hauteur, profondeur);
                glTexCoord2f(1.0, 1.0); glVertex3d( largeur, hauteur, -profondeur);
                glTexCoord2f(0.0, 1.0); glVertex3d( -largeur, hauteur, -profondeur);
            glEnd();
			
	glEndList();
}

/*************************************/
/* Cration de la surface du plateau */
/*************************************/

void construction_surface()
{	
    int i, j;
	surface = glGenLists(1);
	glNewList(surface, GL_COMPILE);
		for (i=0; i<4; i++)
		{	for (j=0; j<4; j++)
			{	
                glPushMatrix();
					glTranslatef(-52+i*35, 0, -52+j*35);
					glCallList(rond);
				glPopMatrix();
			}
		}
	glEndList();
}

/*********************************/
/* Cration des 16 pices du jeu */
/*********************************/

void construction_pieces()
{
	int i;
	
	for (i = 0; i<16; i++)
	{
		pieces[i] = glGenLists(1);
		glNewList(pieces[i], GL_COMPILE);
        	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lum_speculaire);
        	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, eclat);
			glPushMatrix();
                glRotatef(45,0,1,0);
                construire_piece(COULEUR&i,TAILLE&i,REMPLISSAGE&i,64*(FORME&i)+4);
			glPopMatrix();
		glEndList();
	}
}

/***********************/
/* Cration du curseur */
/***********************/

void construction_curseur()
{
    cone = glGenLists(1);
	glNewList(cone, GL_COMPILE);
    	glPushMatrix();
    		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, rose);
	     	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lum_speculaire);
        	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, eclat);
            glScalef(13,13,13);
            glRotatef(90,1,0,0);
            glutSolidCone(1, 2, 4, 4);
        glPopMatrix();
	glEndList();
}


/****************************/
/* Permet d'crire du texte */
/****************************/

void output(int x, int y, int z, char *string)
{
  int len, i;
  glRasterPos3f(x, y, z);
  len = (int) strlen(string);
  for (i = 0; i < len; i++)
  {
    glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, string[i]);
  }
}


/****************************************/
/* Initialisation des lumires et spots */
/****************************************/

void initLights()
{
	glLightfv(GL_LIGHT0,GL_AMBIENT,lum_blanche);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,lum_blanche);
	glLightfv(GL_LIGHT0,GL_SPECULAR,lum_speculaire);
	
	glLightfv(GL_LIGHT1,GL_AMBIENT,lum_peu_speculaire);
	glLightfv(GL_LIGHT1,GL_DIFFUSE,lum_peu_speculaire);
	glLightfv(GL_LIGHT1,GL_SPECULAR,lum_peu_speculaire);
	glLightf(GL_LIGHT1,GL_SPOT_CUTOFF, 22.0);
    
    glLightfv(GL_LIGHT2,GL_AMBIENT,lum_blanche);
	glLightfv(GL_LIGHT2,GL_DIFFUSE,lum_blanche);
	glLightfv(GL_LIGHT2,GL_SPECULAR,lum_speculaire);
	glLightf(GL_LIGHT2,GL_SPOT_CUTOFF, 45);
	
	glLightfv(GL_LIGHT3, GL_AMBIENT, lum_blanche);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, lum_blanche);
	glLightfv(GL_LIGHT3, GL_SPECULAR, lum_blanche);
	glLightf(GL_LIGHT3, GL_SPOT_EXPONENT, 0.8); /* coefficient d'attnuation angulaire */
	glLightf(GL_LIGHT3, GL_SPOT_CUTOFF, 60.0); /* ce spot clairera jusqu' 60 autour de son axe */
}


/********************************************************************/
/* Fonction de chargement d'une image jpeg avec la libraire jpeglib */
/********************************************************************/

void loadJpegImage(char *fichier, int x, int y)
{
	struct jpeg_decompress_struct cinfo ;
	struct jpeg_error_mgr jerr ;
	FILE *file ;
	unsigned char *ligne ;
	
	cinfo.err = jpeg_std_error(&jerr) ;
	jpeg_create_decompress(&cinfo) ;
	if ((file=fopen(fichier,"rb")) == NULL)
    {	fprintf(stderr,"Erreur : impossible d'ouvrir le fichier jpeg\n") ;
		exit(1) ;
	}
	jpeg_stdio_src(&cinfo, file) ;
	jpeg_read_header(&cinfo, TRUE) ;
	
	if (cinfo.jpeg_color_space==JCS_GRAYSCALE)
    {   fprintf(stdout,"Erreur : l'image doit etre de type RGB\n") ;
		exit(1) ;
	}
	jpeg_start_decompress(&cinfo) ;
	ligne = image ;
	while (cinfo.output_scanline < cinfo.output_height)
    {	ligne=image+3*x*cinfo.output_scanline ;
		jpeg_read_scanlines(&cinfo, &ligne, 1) ;
	}
	jpeg_finish_decompress(&cinfo) ;
	jpeg_destroy_decompress(&cinfo) ;
}

/***********************************/
/* Ecriture dans un fichier BitMap */
/***********************************/

int writeBMP(const char *fname,const unsigned char *image,int w, int h)
{
	FILE *fp;
	int ret = 0;

	/* Definition de la structure d un fichier BMP */

	/* Entete d un fichier bmp */
	struct BMPHeader
	{	unsigned short type;
		unsigned int size;
		unsigned short res1;
		unsigned short res2;
		unsigned int offset;
	}  __attribute__((packed)) header;
    
	/* Infos sur l image */
	struct BMPInfo
	{	unsigned int size;
		unsigned int width;
		unsigned int height;
		unsigned short planes;
		unsigned short bit_count;
		unsigned int comp;
		unsigned int sizeImage;
		unsigned int x_pels_per_meter;
		unsigned int y_pels_per_meter;
		unsigned int clr_used;
		unsigned int clr_important;
	} __attribute__((packed)) info;

	/* Ouverture du fichier en ecriture*/ 
	fp = fopen(fname, "wb");
 
        if (!fp)
		{	fprintf(stderr,"Unable to open %s for writing\n",fname);
			ret = -1;
		}
		else
		{	/* Entete du fichier */
			header.type = 'B' | 'M' << 8;
			header.size = sizeof(header) + sizeof(info) + w * h * 3;
			header.res1 = header.res2 = 0;
			header.offset = sizeof(header) + sizeof(info);
			info.size = sizeof(info); 
			info.width = w;
			info.height = h;
			info.planes = 1;
			info.bit_count = 24;
			info.comp = 0;
			info.sizeImage = w * h * 3;
			info.x_pels_per_meter = info.y_pels_per_meter = 0;
			info.clr_used = 0;
			info.clr_important = 0;

			/* Ecriture de l entete dans le fichier */
			fwrite(&header, sizeof(header), 1, fp);
			fwrite(&info, sizeof(info), 1, fp);
			/* Ecriture des donnees brutes de l image */
			fwrite(image, sizeof(unsigned char), h*w*3, fp);
		}

		if (fp)
			fclose(fp);
		
		return ret;
}

/**********************/
/* Capture de l'cran */
/**********************/

int take(const char *fname)
{      
	unsigned char *image = NULL;
	int ret = 0;
	int x = 0;
	int y = 0;
	int width = 600;
	int height = 600;
    
	image = (unsigned char*)malloc(sizeof(unsigned char)*width*height*3);

	if (!image)
	{	fprintf(stderr,"Unable to allocate image buffer\n");
		ret = -1;
	}
	else
	{     
		/* Lecture des pixels de la fenetre */
		glReadPixels(x, y, width, height, GL_BGR, GL_UNSIGNED_BYTE, image);
	   /* Appelle de la fonction de sauvegarde en BMP */
		ret = writeBMP(fname, image, width, height);     
	}
  
	if (image)
		free(image);

	return ret;
}


/*****************************************/
/* Initialisation d'une partie de Quarto */
/*****************************************/

void initPartie()
{
    int i;

    initTableaux();
    mode_jeu = SELECTION;
    joueur = 0;
    victoire = 0;
    nbPieces = 16;
    courante = -1;
    angle_obs = 0;
    obsY = 400;
    tabX = tabY = rainX = 0;
    curseur.x = 125;
    curseur.y = 75;
    curseur.z = 0;
    for (i=0;i<4;i++) pas[i] = .3;
	sprintf(message,"%s choisit la piece.",(joueur==0)?joueur1:joueur2);
}

/*******************************/
/* Initialisation des tableaux */
/*******************************/

void initTableaux()
{
    int i,j;
    for (i=0; i<4; i++)
        for (j=0; j<4; j++)
            tableau[i][j] = -1;
            
	for (i=0; i<16; i++)
	{
		float a = i*2*M_PI/16;
		rainure[i].x = position[i].x = 125*cos(a);
		rainure[i].y = position[i].y = 0;
		rainure[i].z = position[i].z = 125*sin(a);
		piece_rainure[i] = i;
	}
}

/************************************/
/* Ajout d'une pice sur le plateau */
/************************************/

int inserePiece(int x, int y, int piece)
{
    int retour;
    
    tableau[x][y] = piece;
    if (verification(x,LIGNE)) retour = 1;
    else if (verification(y,COLONNE)) retour = 2;
    else if ((y==x) && verification(x,DIAGONALE)) retour = 3;
    else if ((y == (3-x)) && verification(x,ANTIDIAGO)) retour = 4;
    else retour = 0;
    
    return retour;
}

/***********************/
/* Test de la victoire */
/***********************/

int verification(int x, int type)
{
    int i, b1, b2;
    b1 = b2 = 15;
    switch (type)
    {
        case LIGNE:
            for (i=0;i<4;i++)
            {
               if (tableau[x][i] == -1) return 0;
               b1 = b1 & tableau[x][i];
               b2 = b2 & ~tableau[x][i];
            }
            break;
        case COLONNE:
            for (i=0;i<4;i++)
            {
                if (tableau[i][x] == -1) return 0;
                b1 = b1 & tableau[i][x];
                b2 = b2 & ~tableau[i][x];
            }
            break;
        case DIAGONALE:
            for (i=0;i<4;i++)
            {
                if (tableau[i][i] == -1) return 0;
                b1 = b1 & tableau[i][i];
                b2 = b2 & ~tableau[i][i];
            }
            break;
        case ANTIDIAGO:
            for (i=3;i>=0;i--)
            {
                if (tableau[i][3-i] == -1) return 0;
                b1 = b1 & tableau[i][3-i];
                b2 = b2 & ~tableau[i][3-i];
            }
            break;
    }
    return b1 || b2;
}


/***************************/
/* Lecture clavier (ASCII) */
/***************************/

void clavier(unsigned char key,int x,int y)
{
  switch(key)
  {
    case '8':obsY+=7; break;
    case '2':obsY-=7; break;
    case '4':angle_obs=fmod(angle_obs+5,360); glutPostRedisplay(); break;
    case '6':angle_obs=fmod(angle_obs-5,360); glutPostRedisplay(); break;
    case '5':angle_obs=0;obsY=400; break;
    case 0x0D:KeyEnter(); break;
	case 0x08:KeyBackspace(); break;
	case 0x1B:KeyEscape(); break;
	case 'n': initPartie(); break;
  }
  glutPostRedisplay();
}

/**************************************/
/* Lecture Clavier (Touches spciales */
/**************************************/

void keyb(int key, int x, int y)
{
    switch(key)
    {
        case GLUT_KEY_UP:KeyUp();break;
        case GLUT_KEY_DOWN:KeyDown();break;
        case GLUT_KEY_LEFT:KeyLeft();break;
        case GLUT_KEY_RIGHT:KeyRight();break;
    }
}
/********************/
/* Touche de gauche */
/********************/

void KeyLeft()
{
    if (mode_jeu == SELECTION)
    {
        if (nbPieces >= 1)
        {
            do
            {	rainX = (rainX+15)%16;
            }
            while (piece_rainure[rainX] == -1);
            curseur.x = rainure[rainX].x;
            curseur.z = rainure[rainX].z;
        }
    }
    else if (mode_jeu == PLACEMENT)
    {
        tabY = (tabY+3)%4;
        curseur.x = -52+tabY*35;
    }
}

/********************/
/* Touche de droite */
/********************/

void KeyRight()
{
    if (mode_jeu == SELECTION)
    {
        if (nbPieces >= 1)
        {
            do
            {
                rainX = (rainX+1)%16;
            } while (piece_rainure[rainX] == -1);
            curseur.x = rainure[rainX].x;
            curseur.z = rainure[rainX].z;
        }
    }
    else if (mode_jeu == PLACEMENT)
    {
        tabY = (tabY+1)%4;
        curseur.x = -52+tabY*35;
    }
}
        
/******************/
/* Touche du haut */
/******************/

void KeyUp()
{
    if (mode_jeu == PLACEMENT)
    {
        tabX = (tabX+3)%4;
        curseur.z = -52+tabX*35;
    }
}   

/*****************/
/* Touche du bas */
/*****************/

void KeyDown()
{
    if (mode_jeu == PLACEMENT)
    {
        tabX = (tabX+1)%4;
        curseur.z = -52+tabX*35;
    }
}    

/*************************************/
/* Affectation de la touche "entre" */
/*************************************/

void KeyEnter()
{
    if (mode_jeu == SELECTION)
    {
        courante = rainX;
        piece_rainure[rainX] = -1;
        mode_jeu = 1 - mode_jeu;
        joueur = 1 - joueur;
        position[courante].x = 0;
        position[courante].y = -5000;
        position[courante].z = 0;
		sprintf(message,"%s pose la piece",(joueur==0)?joueur1:joueur2);
		sprintf(message2,"%s %s %s %s",
                        (courante&COULEUR)?"Bleue":"Rouge",
                        (courante&TAILLE)?"Grande":"Petite",
                        (courante&REMPLISSAGE)?"Pleine":"Creuse",
                        (courante&FORME)?"Ronde":"Carree");
    }
    else if (mode_jeu == PLACEMENT)
    {
        if (tableau[tabX][tabY] == -1)
        {
            int i;
            
            nbPieces--;
            position[courante].x = -52+tabY*35;
            position[courante].y = 3;
            position[courante].z = -52+tabX*35;
            victoire = inserePiece(tabX,tabY,courante);
            courante = -1;
            if (victoire)
            {
                sprintf(message,"Victoire de %s!",(joueur==0)?joueur1:joueur2);
                switch (victoire)
                {
                    case LIGNE:
                        for (i=0;i<4;i++) pieces_vict[i] = tableau[tabX][i];
                        break;
                    case COLONNE:
                        for (i=0;i<4;i++) pieces_vict[i] = tableau[i][tabY];
                        break;
                    case DIAGONALE:
                        for (i=0;i<4;i++) pieces_vict[i] = tableau[i][i];
                        break;
                    case ANTIDIAGO:
                        for (i=0;i<4;i++) pieces_vict[i] = tableau[i][3-i];
                        break;
                }
                mode_jeu = FIN_JEU;
            }
            else if (nbPieces == 0)
			{
                sprintf(message,"Match nul !");
                mode_jeu = FIN_JEU;
            }
			else
            {
                mode_jeu = SELECTION;
                sprintf(message,"%s choisit la piece",(joueur==0)?joueur1:joueur2);
				curseur.y = 75;
                KeyRight();
            }
        }
    }
}

/*********************************/
/* Touche de "retour en arrire" */
/*********************************/

void KeyBackspace()
{
	if (mode_jeu == PLACEMENT)
	{
		piece_rainure[rainX] = courante;
		joueur = 1 - joueur;
		mode_jeu = 1 - mode_jeu;
        position[courante].x = rainure[courante].x;
        position[courante].y = rainure[courante].y;
        position[courante].z = rainure[courante].z;
		curseur.x = rainure[rainX].x;
        curseur.z = rainure[rainX].z;
        courante = -1;
        sprintf(message,"%s choisit la piece",(joueur==0)?joueur1:joueur2);
	}
}

/**********************/
/* Echap pour quitter */
/**********************/

void KeyEscape()
{
    exit(0);
}


/***********************************/
/* Fonction principale d'affichage */
/***********************************/

void affiche()
{
    int i;
    
    obsX=400*sin(angle_obs*M_PI/180);
    obsZ=400*cos(angle_obs*M_PI/180);
    
    glClearColor(0, 0, 0, 0);
    glClear(GL_COLOR_BUFFER_BIT |  GL_DEPTH_BUFFER_BIT);
    
    /* Premier Viewport: Le plateau et les pices */   
    glViewport(0., 25., 600, 600);
    glMatrixMode(GL_PROJECTION);                        
    glLoadIdentity();
    glFrustum(-10,10,-10,10,30,1000);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();   
    gluLookAt(obsX,obsY,obsZ, 0,0,0, 0,1,0); 
    
	/* Parametrage du placage de textures */
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR) ;
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR) ;

    glDisable(GL_LIGHT1);
	 
    // Lumire principale	
    glLightfv(GL_LIGHT0, GL_POSITION, lum_position);	
	glEnable(GL_LIGHT0);	
	
	// Spot de slction
	if (mode_jeu == SELECTION)
    {
        spot_autour[0] = direction_spot_autour[0] = curseur.x;
        spot_autour[2] = direction_spot_autour[2] = curseur.z;
        glLightfv(GL_LIGHT3, GL_POSITION, spot_autour);
        glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, direction_spot_autour);
        glEnable(GL_LIGHT3);
    } else glDisable(GL_LIGHT3);
    
    // Spot de placement
    if (mode_jeu == PLACEMENT)
	{
	   spot_case[0] = -52+tabY*35;
       spot_case[2] = -52+tabX*35;
       glLightfv(GL_LIGHT2, GL_POSITION, spot_case);
       glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction_spot_case);
       glEnable(GL_LIGHT2);
    }
    else glDisable(GL_LIGHT2);
    
    // Curseur de slection
    if (mode_jeu == SELECTION)
    {
        glPushMatrix();
			glTranslatef(curseur.x,curseur.y,curseur.z);
			glPushMatrix();
                glRotatef(angle_cone,0,1,0);
                glCallList(cone);
            glPopMatrix();
        glPopMatrix();
    }	

    /* Placement de tous les objets */
	for (i=0;i<16;i++)
	{
		glPushMatrix();	
			glTranslatef(position[i].x,position[i].y,position[i].z);
			glScalef(13,13,13);
			glCallList(pieces[i]);  
		glPopMatrix();
	}
	
	glEnable(GL_TEXTURE_2D); // Activation des textures
	glPushMatrix();
    	glTranslatef(0,-1,0);
    	glCallList(plateau);
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	
	glPushMatrix();
        glCallList(surface);	
	glPopMatrix();


    /* 2e Viewport: le texte */
    glViewport(0, 0, 600, 100);
    glMatrixMode(GL_PROJECTION);                        
    glLoadIdentity();
    glFrustum(-100,100,-100,100,30,1000);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();   
    gluLookAt(0,5000,60, 0,5000,0, 0,1,0); 

    glDisable(GL_LIGHTING);
	glPushMatrix();
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, blanc);
	     	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lum_nulle);
        	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, eclat);
			output(-125,5005,0,message);
			if (mode_jeu == PLACEMENT) 
                output(-125,4905,0,message2);
	glPopMatrix();
    glEnable(GL_LIGHTING);
	
	
	/* 3e Viewport: Piece selectionne */
	glViewport(0, 0, 150, 150);
    glMatrixMode(GL_PROJECTION);                        
    glLoadIdentity();
    glFrustum(-25,25,-25,25,35,100);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();   
    gluLookAt(0,-4930,60, 0,-5000,0, 0,1,0);
    
    if (mode_jeu == PLACEMENT)
	{
        glLightfv(GL_LIGHT1,GL_SPOT_DIRECTION, direction_spot_piece);
        glLightfv(GL_LIGHT1,GL_POSITION,spot_piece);
		glEnable(GL_LIGHT1);	
        glPushMatrix();	
			glRotatef(angle_piece,0,1,0);
            glTranslatef(position[courante].x,position[courante].y,position[courante].z);
			glScalef(13,13,13);
			glCallList(pieces[courante]);  
	   glPopMatrix();
    }
	else glDisable(GL_LIGHT1);
	
	glutSwapBuffers();
}

/***************************************/
/* Gre l'agrandissement de la fentre */
/***************************************/

void rafraichit()
{
    glViewport(0,0,600,600);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
}

/********************************/
/* Fonction excute sans cesse */
/********************************/

void idle()
{
    int i;
    float j = 0;

    angle_cone = fmod(angle_cone+1,360);
    angle_piece = fmod(angle_piece+.5,360);
    
    /* Animation de victoire */
    if (mode_jeu == FIN_JEU && victoire != MATCH_NUL)
    {
        for (i=0;i<4;i++)
        {
            j = position[pieces_vict[i]].y + pas[i] + i*pas[i];
            if (j > 13)
            {
                j = 13;
                pas[i] = -pas[i];
            } 
            else if (j < 3)
            {
                j = 3;
                pas[i] = -pas[i];
            }
            position[pieces_vict[i]].y = j;
        }
    }
    glutPostRedisplay();
}


/*******************************/
/* Affiche l'aide  la console */
/*******************************/

void help()
{
	printf("*******************\n* Aide sur QUARTO *\n*******************\n\n");
	printf("- Creer une nouvelle partie : Touche << n >>\n");
	printf("- Choisir une piece / un emplacement : Touche << Up, Down, Left et Right >>\n");
	printf("- Selectionner une piece : Touche << Enter >>\n");
	printf("- Annuler la selection d'une piece : Touche << BackSpace >>\n");
	printf("- Changer la vue de l'observateur : Pave Numerique << 4, 8, 6 et 2 >>\n");
	printf("- Reinitialiser la vue : Pave Numerique << 5 >>\n");
	printf("- Quitter : Touche << Echap >>\n");
}

/***************************************/
/* Menu droulant de la fentre OpenGL */
/***************************************/

void menu(int selection)
{
	switch (selection)
	{	
        case 1 : initPartie(); break;
        case 2 : sprintf(path,"./captures/capture%d.bmp",nb_capture++); take(path); break;
        case 3 : help(); break;
        case 0 : exit(0); break;
	}
	glutPostRedisplay();
}


/************************/
/* FPorgramme Principal */
/************************/

int main (int argc, char ** argv)
{    
    int i, j;
    
    /* Chargement de la texture */
	loadJpegImage("texture.jpg", 256, 256) ;
	for (i=0;i<256;i++)
	{	
        for (j=0;j<256;j++)
        {	
            texture[i][j][0]=image[i*256*3+j*3] ;
			texture[i][j][1]=image[i*256*3+j*3+1] ;
			texture[i][j][2]=image[i*256*3+j*3+2] ;
		}
	}
	
	/* Saisie du nom des joueurs*/
	printf("Nom du Joueur 1: ");
	fgets(joueur1,64,stdin);
	printf("Nom du Joueur 2: ");
	fgets(joueur2,64,stdin);
	
    /* Initialisations */	
    initPartie();
    
    glutInit(&argc, argv);    
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    
    glutInitWindowSize(600,600);
    glutInitWindowPosition(10,10);
    glutCreateWindow("Quarto");
    
    glEnable(GL_DEPTH_TEST); /* Z Buffer */
    glEnable(GL_LIGHTING); /* Lumiere */
	glEnable(GL_RESCALE_NORMAL); /* normaliser */
    
    initObjets();
    initLights();    
    
    glutDisplayFunc(&affiche);
    glutReshapeFunc(&rafraichit);
    glutIdleFunc(&idle); 
    glutKeyboardFunc(&clavier);
    glutSpecialFunc(&keyb);
    
	glutCreateMenu(&menu);
	glutAddMenuEntry("Nouvelle Partie",1);
	glutAddMenuEntry("Capture d'cran",2);
	glutAddMenuEntry("Les raccourcis clavier",3);
	glutAddMenuEntry("Quitter",0);
	glutAttachMenu(GLUT_RIGHT_BUTTON);

    glutMainLoop();
    
    return(0);
}
