#ifndef __piece_h__
#define __piece_h__

#include <GL/glut.h>
#include <GL/glext.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <jpeglib.h>
#include <jerror.h>
#include "vect.h"
#include "construct.h"

#define COULEUR 8
#define TAILLE 4
#define REMPLISSAGE 2
#define FORME 1

#define SELECTION 0
#define PLACEMENT 1
#define FIN_JEU 2

#define MATCH_NUL 0
#define LIGNE 1
#define COLONNE 2
#define DIAGONALE 3
#define ANTIDIAGO 4

/* Elments graphiques */
void initObjets();
void construction_rond();
void construction_plateau();
void construction_surface();
void construction_pieces();
void construction_curseur();

/* Texte graphique */
void output(int,int,int,char*);

/* Lumires */
void initLights();

/* Gestion des textures, et capture d'ecran */
void loadJpegImage(char*,int,int);
int writeBMP(const char *,const unsigned char *,int,int);
int take(const char *);

/* Traitement du jeu */
void initPartie();
void initTableaux();
int inserePiece(int,int,int);
int verification (int,int);

/* Clavier */
void clavier(unsigned char,int,int);
void keyb(int,int,int);
void KeyLeft();
void KeyRight();
void KeyUp();
void KeyDown();
void KeyEnter();
void KeyBackspace();
void KeyEscape();

/* Fonctions ncessaires en openGL */
void affiche();
void rafraichit();
void idle();

/* Aide et menu */
void help();
void menu(int);

#endif
